<script setup lang="ts">
import {useStockStore} from "@/stores/stock"




import { onMounted, ref } from "vue";


const stockStore = useStockStore()
const  headers =[
          {
        
            key: 'id',
            sortable: false,
            title: 'ProuductId',
          },
          { key: 'name', title: 'ProuductName' },
          { key: 'minimum', title: 'Minimum' },
          { key: 'balance', title: 'Balance' },
          { key: 'unit', title: 'Unit' },
          { key: 'price', title: 'Price' },
          { title: 'Actions', key: 'actions', sortable: false },
        ]
const search =ref('')
const loading = ref(false)
function openShowReceipt(){
  stockStore.dialogShowReceipt =!stockStore.dialogShowReceipt
}
function closeDialog(){
  stockStore.closeDialogT()
}
onMounted(() => {
  stockStore.getStocks()
})
</script>
<template>
     <v-row no-gutters>
            <v-col cols="12" md="5" >
                <v-text-field
                v-model="search"
                density="compact"
                variant="solo"
                label="Search Stock Item"
                append-inner-icon="mdi-magnify"
                single-line
                hide-details
               
                style="width: 200px;"
                >
                </v-text-field>
            </v-col>
            <v-col cols="12" md="5" style="padding-top: 0px; "  >
            <div><v-btn prepend-icon="mdi-plus" style="margin-left: 550px;" @click="stockStore.openAddDialog ">Product Add</v-btn></div>  
            </v-col>
        </v-row>
    <v-data-table 
            :headers="headers"
            :items="stockStore.stockItems"
            :search="search"
            :items-per-page="8"
            >

        <template v-slot:top>
          <v-dialog
      v-model="stockStore.dialogE"
      persistent
      width="1024"
    >
      <v-card>
        <v-card-title>
          <span class="text-h5">Edit Stock Product</span>
        </v-card-title>
        <v-card-text>
          <v-form ref="refform" v-model="stockStore.formS">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
            <v-text-field

          v-model="stockStore.editedSProduct.name"
          :readonly="loading"
          :rules="[(v) =>!!v || 'Field is required']"
          class="mb-2"
          clearable
          label="Product Name"
        ></v-text-field>
            </v-col>
          <v-col cols="12" sm="12" md="4">
            <v-text-field
          v-model="stockStore.editedSProduct.minimum"
          :readonly="loading"
          :rules="[(v) =>!!v || 'Field is required',(v) => v>0||'Minimum is Lower']"
          class="mb-2"
          clearable
          label="Minimum"
        ></v-text-field>
          </v-col >
        
          <v-col cols="12" sm="12" md="4">
            <v-text-field
          v-model="stockStore.editedSProduct.price"
          :readonly="loading"
          :rules="[(v) =>!!v || 'Field is required',(v) => v>0||'Price is Lower']"
          class="mb-2"
          clearable
          label="Price"
        ></v-text-field>
          </v-col>

          <v-col cols="12" sm="6">
         <v-text-field
          v-model="stockStore.editedSProduct.unit"
          :readonly="loading"
          :rules="[(v) =>!!v || 'Field is required',(v) => !/\d/.test(v) || 'Field cannot contain numbers']"
          class="mb-2"
          clearable
          label="Unit"
        ></v-text-field>
        </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog">
                  Close
                </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="stockStore.save">
                  Save
                </v-btn>
              </v-card-actions>
            </v-card>
    </v-dialog>
        <v-dialog v-model="stockStore.dialogDelete" max-width="500px">
           <v-card>
            <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue-darken-1" variant="text" @click="stockStore.closeDelete">Cancel</v-btn>
              <v-btn color="blue-darken-1" variant="text" @click="stockStore.deleteItemConfirm">OK</v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>
     
    </template>    
           
<template v-slot:[`item.actions`]="{ item }">
      <v-icon
        size="small"
        class="me-2"
        @click="stockStore.editSProduct(item)"
      >
        mdi-pencil
      </v-icon>
      <v-icon
        size="small"
        @click="stockStore.deleteSProduct(item)"
      >
        mdi-delete
      </v-icon>
    </template>
    
  
   

    </v-data-table>
   
</template>